#include <stdio.h>
#include <string.h>

long i,jcount,iok;

char* charpoint;

FILE* infile;
FILE* settingsfile;
FILE* outfile;
FILE* editlistfile;

char indirname[1024];
char infilename[1024];
char editfilename[1024];
char iodirectory[1024];
char leafname[1024];
char tempname[1024];
char appdirname[1024];
char settingsfilename[1024];
char outdirname[1024];
char outfilename[1024];
char avutilname[1024];
char avtype[64];
char ssstring[64];
char tsstring[64];
char commandstring[1024];

long sh,sm,ss,th,tm,ts,tsecs,xh,xm,xs,ssecs,dsecs;


long i,ok;

long read_settingsfile(void);


int main(int argc,char*argv[])
{
  printf("AVchopper v0.10\nJim Lesurf Jan 2015\n\n");
  i=argc;
  printf("Number of arguments given = %ld\n\n",i);
  
  sprintf(appdirname,"%s",argv[0]);
  ok=(long)strrchr(appdirname,'/')-(long)appdirname;
  appdirname[ok]=(char)0;
  printf("Application directory = %s\n",appdirname);
  sprintf(settingsfilename,"%s/%s",appdirname,"Settings");
  printf("Settings file at %s\n",settingsfilename);
  
  if(i==1)
  {
    printf("\n\nDrag an editfile to the Application icon\n");
    printf("to generate a series of output AV files.\n");
    printf("\n\nPlease read the help inside the application\n");
    printf("first for more details!\n\n");
  }
  
  if(i==2)
  {
    sprintf(editfilename,"%s",argv[1]);
    sprintf(iodirectory,"%s",editfilename);
    sprintf(leafname,"%s",1+strrchr(editfilename,'/'));
    ok=(long)strrchr(iodirectory,'/')-(long)iodirectory;
    iodirectory[ok]=(char)0;
    ok=(long)strrchr(iodirectory,'/')-(long)iodirectory;
    iodirectory[ok]=(char)0;
    printf("Edit file = %s\n",editfilename);
    printf(" leafname = %s \n",leafname);
    printf("I/O directory = %s\n",iodirectory);
    ok=read_settingsfile();
    i=0;
    printf(" Enter start number for output file count => ");
    scanf("%ld",&i);
    
    
    editlistfile=fopen(editfilename,"rt");
    
    sh=0; sm=0; ss=0; ssecs=0;
    
    
    while ( fscanf(editlistfile,"%ld:%ld:%ld",&th,&tm,&ts)==3)
    {
      printf("line %ld %ld %ld => ",th,tm,ts);
      
      ssecs=3600*sh + 60*sm + ss;
      
      
      if(ssecs>0)
      {
        sprintf(ssstring," -ss \"%02ld:%02ld:%02ld\" ",sh,sm,ss);
      }
      else
      {
        sprintf(ssstring,"  ");
      }
      
      dsecs=3600*(th-sh) + 60*(tm-sm) + (ts-ss);
      
      xh=th; xm=tm; xs=ts;
      sh=th; sm=tm; ss=ts;
      
      th=dsecs/3600; dsecs -= 3600*th;
      
      tm=dsecs/60;   dsecs -=  60*tm;
      
      ts=dsecs;
      
      sprintf(tsstring," -t \"%02ld:%02ld:%02ld\" ",th,tm,ts);
      
      printf(" %s and %s\n",ssstring,tsstring);
      
      sprintf(commandstring,"%s %s -i %s -acodec copy -vcodec copy %s %s/%02ld_%s%s",avutilname,ssstring,infilename,tsstring,outdirname,i,leafname,avtype);
      printf("command =\n  %s\n\n",commandstring);
      
      system(commandstring);
      
    i++;  
    }
    
    printf("last part\n");
    
    sprintf(ssstring," -ss \"%02ld:%02ld:%02ld\" ",xh,xm,xs);
    sprintf(tsstring,"  ");
    printf(" %s and %s\n",ssstring,tsstring);
    
    sprintf(commandstring,"%s %s -i %s -acodec copy -vcodec copy %s %s/%02ld_%s%s",avutilname,ssstring,infilename,tsstring,outdirname,i,leafname,avtype);
    printf("command =\n  %s\n\n",commandstring);
    
    system(commandstring);
    
  
  }
  
  printf("Done!\n");
  return 0;
}

  

long read_settingsfile(void)
{
  long result;
  sprintf(settingsfilename,"%s/Settings",appdirname);
  printf("\nSettings file at %s\n",settingsfilename);

  settingsfile=fopen(settingsfilename,"rt");
  
  fscanf(settingsfile,"%s",avutilname);
  printf(" Will use %s for conversions\n",avutilname);
  fscanf(settingsfile,"%s",avtype);
  printf(" file type set to %s\n",avtype);
  
  fscanf(settingsfile,"%s",tempname);
  sprintf(indirname,"%s/%s",iodirectory,tempname);
  printf("Input taken from   dir = %s\n",indirname);
  sprintf(infilename,"%s/%s%s",indirname,leafname,avtype);
  printf(" from file = %s\n\n",infilename);
  
  fscanf(settingsfile,"%s",tempname);
  sprintf(outdirname,"%s/%s",iodirectory,tempname);
  printf("Output will go into dir = %s\n",outdirname);
  
  fclose(settingsfile);
  result=1;
  return result;
}



